#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################


if ($q->param('fct') eq "get_email") {&get_email; exit;}

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "retrieve_email") {&retrieve_email;}
if ($q->param('fct') eq "") {&start;}


##################################################################################


sub start
{


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Email Mailing & Email Retrieveal", qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="91%" class="normaltext">This area enables you to send email to link owners and
    to retrieve email addresses if you would like to use third party mailing software. </td>
    <td width="4%" align="right" valign="top" class="normaltext"><a
    href="$admin_url/help.cgi?fct=email_send" target="_blank"><strong><img
    src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
]);



print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="0" bgcolor="#DADADA" height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="90" align="center"><img
    src="$web_url/ic_email2.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6" cellspacing="1">
      <tr class="normaltext">
        <td><strong><a href="$admin_url/admin64.cgi">Send
        Email To Link Owners </a><br>
        </strong>Choose this option to send email to link owners. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="90" align="center"><img
    src="$web_url/ic_email2.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6" cellspacing="1">
      <tr>
        <td class="normaltext"><strong><a
    href="$admin_url/admin33.cgi?fct=retrieve_email">Retrieve Email Addresses of Link Owners </a><br>
        </strong>Retrieve email addresses of link owners for third party mailing software. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="90" align="center"><img
    src="$web_url/ic_email3.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6" cellspacing="1">
      <tr>
        <td class="normaltext"><strong><a href="$admin_url/admin65.cgi">Send
        Email To Premium Link Owners </a><br>
        </strong>Choose this option to send email to premium link owners. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="90" align="center"><img
    src="$web_url/ic_email3.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6" cellspacing="1">
      <tr>
        <td class="normaltext"><strong><a href="$admin_url/admin25.cgi">Retrieve
        Email Addresses of Premium Link Owners </a><br>
        </strong>Retrieve email addresses of Premium link owners for third party mailing software. </td>
      </tr>
    </table>
    </td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="90" align="center"><img
    src="$web_url/ic_email1.gif"> </td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><table width="100%" border="0" cellpadding="6" cellspacing="1">
      <tr>
        <td class="normaltext"><strong><a href="$admin_url/admin63.cgi">Send
        Email To Users </a><br>
        </strong>Use the above option to send email to users who has user accounts. With this
        option you can send email to users who registered user accounts to be able to submit
    links. </td>
      </tr>
    </table>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>

];


}



sub get_email
{

$filename = $q->param('filename');

#storing info from prev form
open (RTCFG, "> $data_dir/emailrtr.cfg");
	print RTCFG $q->param('title'). "\n";			#0
	print RTCFG $q->param('description'). "\n";		#1
	print RTCFG $q->param('keywords'). "\n";		#2
	print RTCFG $q->param('url'). "\n";			#3
	print RTCFG $q->param('name'). "\n";			#4
	print RTCFG $q->param('rating'). "\n";			#5
	print RTCFG $q->param('votes'). "\n";			#6
	print RTCFG $q->param('hits'). "\n";			#7
	print RTCFG $q->param('lnkpassword'). "\n";		#8
	print RTCFG $q->param('lnkpassword_url'). "\n";		#9
	print RTCFG $q->param('rating_link'). "\n";		#10
	print RTCFG $q->param('cat'). "\n";			#11
	print RTCFG $q->param('seperator'). "\n";		#12
	print RTCFG $q->param('subsr'). "\n";			#13
close (RTCFG);


####################



if (($filename eq "") and ($q->param('roptions') eq "Export To a File"))
	{
	print "Content-type: text/html\n\n";
	acs::problem_popup("You have chosen to export email addresses to a file. Please specify a file name.");
	}


if ($q->param('roptions') eq "Export To a File")
	{
	print "Content-type: text/html\n\n";
	}
	else
	{
	print "Content-type: text/plain\n\n";
	#print "Content-type: text/html\n\n";
	print "\nRetrieving Email Addresses:\n";
	print "===========================\n\n";
	}


### DO ERROR CHECKING


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

	#if ($q->param('roptions') eq "Export To a File")
	#{
	#INTO OUTFILE '$data_dir/$filename' $fields_terminated_by
	#}

	if ($q->param('seperator') eq "") 
			{ $seperator = "\t"; }
			else
			{ $seperator = $q->param('seperator'); }

	#####

$cid = $q->param('cid');
$dupchk = $q->param('Dups'); #duplicate-checkbox
if ($cid eq "")
	{
	if ($q->param('subsr') eq "Y")
		{
		$subsonly = "AND (subscribed = 'Y')";
		}
	
	#if ($dupchk eq "ON")
	#	{
	#	$group = "group by B.title,B.email";
	#	}
	
	if ($q->param('R1') eq "email")
		{
		$group = "group by B.email";
		}
	elsif ($q->param('R1') eq "title")
		{
		$group = "group by B.title";
		}
	
	$sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.*
				FROM dirs AS A,
					  links AS B
			   WHERE (A.cid = B.cid) AND
			         ((B.email IS NOT NULL) AND (B.email != '') $subsonly)
			         $group
			  	ORDER BY B.email
			   ";
	#print "blank cid. \n $sql \n";
	}
	elsif (($cid ne "") and ($q->param('subcats') eq ""))
	{
	if ($q->param('subsr') eq "Y")
		{
		$subsonly = "AND (subscribed = 'Y')";
		}	
	#if ($dupchk eq "ON")
	#	{
	#	$group = "group by B.title,B.email";
	#	}	

	if ($q->param('R1') eq "email")
		{
		$group = "group by B.email";
		}
	elsif ($q->param('R1') eq "title")
		{
		$group = "group by B.title";
		}
	
	$sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.*
				FROM dirs AS A,
					  links AS B
			   WHERE (A.cid = B.cid) AND
			         ((B.email IS NOT NULL) AND (B.email != '')) AND
			         (A.cid = '$cid') 
			         $group
			  	ORDER BY B.email
			   ";
	#print "cid,no subcat. <>$sql<>\n";
	}
	else
	{
	$ecat = $q->param('ecat');
	@ecats = split (/\//, $ecat);
#print "cid,subcat. <>$sql<>\n";
	$lvc = 1;
	foreach $item (@ecats)
		{ print "[]$item\n";
		$dcat = acs::decode_dir($item);
		$dcat =~ s/'/\\'/g; 
		$where_sql = $where_sql . " (A.l" . $lvc . "='$dcat') AND";
		$lvc++;
		#print ("dcat: $dcat::");
		#print ("sql...$where_sql\n");
		}
	
	$where_sql = substr($where_sql, 0, length($where_sql) - 3);
	
	#if ($dupchk eq "ON")
	#	{
	#	$group = "group by B.title,B.email";
	#	}	
	
	if ($q->param('R1') eq "email")
		{
		$group = "group by B.email";
		}
	elsif ($q->param('R1') eq "title")
		{
		$group = "group by B.title";
		}
	
	$sql = "SELECT A.l1,A.l2,A.l3,A.l4,A.l5,A.l6,A.l7,A.l8,A.l9,A.l10,A.l11,A.l12,A.l13,A.l14,A.l15,A.l16, B.*
				FROM dirs AS A,
					  links AS B
			   WHERE (A.cid = B.cid) AND
			         ((B.email IS NOT NULL) AND (B.email != '')) AND
			         $where_sql
			         $group
			  	ORDER BY B.email
			   ";
	}


	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

		if ($q->param('roptions') eq "Export To a File")
			{
			open (EXPFILE, "> $data_dir/$filename");
			}
	
	while ( @row = $sth->fetchrow() )
		{ 
		$cats	= "";
		for ($ms1 = 0; $ms1 < 16; $ms1++) 
			{
			if ($row[$ms1] ne "")
				{
				$cats = $cats . $row[$ms1] . "/";
				}
			}

		$write_line = "";
		
		$write_line = $write_line . "$row[25]" . $seperator;

		if ($q->param('title') ne "") { $write_line = $write_line . $row[18] . $seperator; }

		if ($q->param('description') ne "") 
				{
				$row[19] =~ s/\n//g;
				$crit = chr(10); $row[19] =~ s/$crit/ /g;
				$crit = chr(13); $row[19] =~ s/$crit/ /g; 
				$write_line = $write_line . $row[19] . $seperator; 
				}
				
		if ($q->param('keywords') ne "") { $write_line = $write_line . $row[20] . $seperator; }
		if ($q->param('url') ne "") { $write_line = $write_line . $row[21] . $seperator; }
		
		if ($q->param('name') ne "") { $write_line = $write_line . $row[24] . $seperator; }
		
		if ($row[26] eq "") { $row[26] = 0; }
		if ($q->param('rating') ne "") { $write_line = $write_line . $row[26] . $seperator; }
		
		if ($row[26] eq "") { $row[27] = 0; }
		if ($q->param('votes') ne "") { $write_line = $write_line . $row[27] . $seperator; }
		
		if ($row[26] eq "") { $row[28] = 0; }
		if ($q->param('hits') ne "") { $write_line = $write_line . $row[28] . $seperator; }
		
		if ($q->param('lnkpassword') ne "") { $write_line = $write_line . $row[38] . $seperator; }
		
		if ($q->param('lnkpassword_url') ne "") { $write_line = $write_line . "$script_url/modify.cgi?id=$row[16]&cid=$row[17]" . $seperator; }
		if ($q->param('rating_link') ne "") { $write_line = $write_line . "$script_url/gethtml.cgi?id=$row[16]-$row[17]" . $seperator; }
		
		if ($q->param('cat') ne "") { $write_line = $write_line . $cats . $seperator; }
		
			$write_line = substr($write_line, 0, length($write_line) - length($seperator));
		
			if ($q->param('roptions') eq "Export To a File")
				{
				print EXPFILE $write_line . "\n";
				}
				else
				{ #normal web output
				print "$write_line\n";
				}
		
		} #end while

#####

if ($q->param('roptions') eq "Export To a File")
	{
	close (EXPFILE);
	chmod(0777,"$data_dir/$filename","$data_dir/$filename"); 


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Email Address Retrieval", qq[
Email addresses written to: <strong>$data_dir/$filename<br>
<a href="$admin_url/admin33.cgi">Click here to continue</a>
]);



print <<END_OF_RETRIEVED;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox
</body>
</html>

END_OF_RETRIEVED
	}
	

#####
}



sub retrieve_email
{

$approve_email = acs::get_file_contents("$data_dir/emailrtr.cfg"); 

@emcfg = split (/\n/, $approve_email);
#print "@emcfg<br>";
if ($emcfg[0] ne ""){ $emcfg[0] = "checked"; }
if ($emcfg[1] ne ""){ $emcfg[1] = "checked"; }
if ($emcfg[2] ne ""){ $emcfg[2] = "checked"; }
if ($emcfg[3] ne ""){ $emcfg[3] = "checked"; }
if ($emcfg[4] ne ""){ $emcfg[4] = "checked"; }
if ($emcfg[5] ne ""){ $emcfg[5] = "checked"; }
if ($emcfg[6] ne ""){ $emcfg[6] = "checked"; }
if ($emcfg[7] ne ""){ $emcfg[7] = "checked"; }
if ($emcfg[8] ne ""){ $emcfg[8] = "checked"; }
if ($emcfg[9] ne ""){ $emcfg[9] = "checked"; }
if ($emcfg[10] ne ""){$emcfg[10] = "checked"; }
if ($emcfg[11] ne ""){$emcfg[11] = "checked"; }
if ($emcfg[13] ne ""){$emcfg[13] = "checked"; }

##############################

if ($q->param('cid') ne "")
{

$cid = $q->param('cid');
#print "$cid<br>";

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM dirs WHERE cid = '$cid'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 

while ( @row = $sth->fetchrow() )
	{
  	$cats	= "";
 	for ($ms1 = 2; $ms1 < 18; $ms1++) 
 		{
 		if ($row[$ms1] ne "")
 			{
 			$ecat = $ecat . acs::encode_dir($row[$ms1]) . "/"; 
 			$cats = $cats . $row[$ms1] . "/";
 			}
 		}
	} 

$sth->finish;
$dbh->disconnect;

$cat_info = <<END_OF_CATINFO;
<p><font face="Verdana" size="1"><strong>You have chosen to retrieve email addresses of category/directory:<br>
<font color="#0000FF">$cats</font></strong></font></p>
END_OF_CATINFO


$subcat_retrieval = <<END_OF_SCR;
<tr>
 <td bgcolor="#FFFFFF" width="144"><strong><font face="Verdana" size="1">Retrieve Email Addresses of All subcategories/subdirectories?</font></strong></td>
 <td bgcolor="#FFFFFF" width="622"><font face="Verdana" size="1">
    <input type="checkbox" name="subcats" value="Y">
    Checking this box will retrieve email addresses for all categories/directories below:<br>
    <strong>$cats</strong></font></td>
</tr>
END_OF_SCR

$ecat = substr($ecat, 0, length($ecat) -1);

$hdc_val = <<END_OF_SRET;
<input type="hidden" name="scd_retrieval" value="true">
<input type="hidden" name="cid" value="$cid">
<input type="hidden" name="ecat" value="$ecat">
END_OF_SRET

}

##############################



$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Email Address Retrieval", qq[

</strong>Enables you to retrieve email addresses of link owners. <br>
<b><a href="$admin_url/admin33.cgi">Email Mailing &amp; Address Retrieval </a>&gt;&gt; Email Address Retrieval</b>
]);






print <<END_OF_RS;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox

$cat_info

<form method="POST" action="$admin_url/admin33.cgi">
  <input type="hidden" name="fct" value="get_email">$hdc_val
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="780" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Export
      Email Addresses </strong></td>
    </tr>
    <tr>
      <td width="766" colspan="2" bgcolor="#FFFFFF" class="normaltext"><strong>Fields To Include With Email
      Retrieval: <br>
      </strong>This option enables you to include some more information (like names, link
      titles, descriptions, passwords, etc.) when retrieving the email addresses. This can be
      handy if you would like to include names, link titles, descriptions, etc.. in the emails
      you send to users. <p><input name="title" type="checkbox" value="Y" $emcfg[0]> Title <br>
      <input name="description" type="checkbox" value="Y" $emcfg[1]> Description <br>
      <input name="keywords" type="checkbox" value="Y" $emcfg[2]> Keywords <br>
      <input name="url" type="checkbox" value="Y" $emcfg[3]> Url <br>
      <input name="name" type="checkbox" value="Y" $emcfg[4]> Name <br>
      <input name="rating" type="checkbox" value="Y" $emcfg[5]> Rating <br>
      <input name="votes" type="checkbox" value="Y" $emcfg[6]> Votes <br>
      <input name="hits" type="checkbox" value="Y" $emcfg[7]> Hits <br>
      <input name="lnkpassword" type="checkbox" value="Y" $emcfg[8]> Modify Password <br>
      <input name="lnkpassword_url" type="checkbox" value="Y" $emcfg[9]> Link to Modify Page <br>
      <input name="rating_link" type="checkbox" value="Y" $emcfg[10]> Link where link owners can
      get rating code to put on their web pages <br>
      <input name="cat" type="checkbox" value="Y" $emcfg[11]> Category <br>
      <input name="subsr" type="checkbox" value="Y" $emcfg[13]> Only Users Who Ticked the
      Subcribe Box When They Made a Submission </p>
      <strong><p><strong>By what character would you like the fields to be separated:</strong> 
        <input
      name="seperator" value="$emcfg[12]" size="3"> (Default is a tab character) <br>
      &nbsp; </p>
      <p><input type="radio" value="email" checked name="R1"> Prevent duplicates on e-mails <br>
      <input type="radio" name="R1" value="title"> Prevent duplicates on titles <br>
      <br>
      </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"><strong>How to retrieve addresses? </strong></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><strong>
        <select name="roptions" size="1">
        <option value="To Browser Window"> To Browser Window </option>
        <option value="Export To a File"> Export To a File </option>
      </select> </strong></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"><strong>Filename: </strong></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="filename" size="32"> <br>
      Specify a file name if you have chosen 'Export to a File' above. The file will be placed
      in: <strong>$data_dir/yourfilename.txt </strong></td>
    </tr>
$subcat_retrieval
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Retrieve   " name="B1"> </td>
    </tr>
  </table>
</form>



<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

  
</form>


</body>
</html>

END_OF_RS

}
#<input type="checkbox" name="Dups" value="ON">Prevent Duplicates


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

